## libvpoll-eventfd 0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(vpoll
		VERSION 0.0.1
		DESCRIPTION "generate synthetic events for poll/select/ppoll/pselect/epoll"
		HOMEPAGE_URL "https://github.com/rd235/libvpoll-eventfd"
		LANGUAGES C)

include(GNUInstallDirs)
add_definitions(-D_GNU_SOURCE)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -O2 -D_FORTIFY_SOURCE=2")

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
if (PROJECT_INCLUDEDIR)
  include_directories(${PROJECT_INCLUDEDIR})
  execute_process(COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/vpoll.h ${PROJECT_INCLUDEDIR}/.)
endif (PROJECT_INCLUDEDIR)

set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

set(VPOLL_SOURCES vpoll.c)
add_library(vpoll SHARED ${VPOLL_SOURCES})
target_link_libraries(vpoll fduserdata)

set_target_properties(vpoll PROPERTIES VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR})

set(PROJECT_PC_REQUIRES "fduserdata")
configure_file(vpoll.pc.in vpoll.pc @ONLY)

install(TARGETS vpoll LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES vpoll.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/vpoll.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

add_subdirectory(man)

=== linux_module/Makefile ===
obj-m += vpoll.o

all:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) modules
clean:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) clean

=== debian/changelog ===
libvpoll-eventfd (0.1-2ubuntu2) jammy; urgency=medium

  * Support Linux 6.5 (LP: #2045034):
    - debian/patches/0002-Linux-6.5-support-class-create.patch

 -- Andrea Righi <andrea.righi@canonical.com>  Tue, 28 Nov 2023 13:59:33 +0000

libvpoll-eventfd (0.1-2ubuntu1) jammy; urgency=medium

  * Support Linux 6.2 (LP: #2007534):
    - debian/patches/0001-Linux-6.2-fix-vpoll_devnode-parameter.patch

 -- Andrea Righi <andrea.righi@canonical.com>  Tue, 13 Jun 2023 09:44:12 +0000

libvpoll-eventfd (0.1-2) unstable; urgency=medium

  * Source only upload for migration to testing

 -- Andrea Capriotti <capriott@debian.org>  Fri, 05 Feb 2021 23:11:21 +0100

libvpoll-eventfd (0.1-1) unstable; urgency=medium

  * Initial release (Closes: #976330)

 -- Andrea Capriotti <capriott@debian.org>  Mon, 18 Jan 2021 17:51:24 +0100

=== debian/control ===
Source: libvpoll-eventfd
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
Uploaders: Mattia Biondi <mattia.biondi3@studio.unibo.it>, Renzo Davoli <renzo@cs.unibo.it>, Andrea Capriotti <capriott@debian.org>
Build-Depends: debhelper-compat (= 13), cmake (>= 3.12), libfduserdata-dev (>= 0.1),
  dkms
Standards-Version: 4.5.1
Section: libs
Homepage: http://www.virtualsquare.org/
Vcs-Git: https://salsa.debian.org/virtualsquare-team/libvpoll-eventfd.git
Vcs-Browser: https://salsa.debian.org/virtualsquare-team/libvpoll-eventfd
Rules-Requires-Root: no

Package: libvpoll-dev
Section: libdevel
Architecture: any
Depends: libvpoll0 (= ${binary:Version}), ${misc:Depends}
Description: generate synthetic events for poll/select/ppoll/pselect/epoll (devel)
 This library uses eventfd/VPOLL if provided by the kernel or the vpoll device
 otherwise it implements an emulator (providing only `EPOLLIN`, `EPOLLOUT`
 and a non standard version of EPOLLHUP/EPOLLRDHUP).
 .
 This package contains the development files used for C programs.

Package: libvpoll0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfduserdata0 (>= 0.1)
Recommends: vpoll-dkms
Description: generate synthetic events for poll/select/ppoll/pselect/epoll (library)
 This library uses eventfd/VPOLL if provided by the kernel or the vpoll device
 otherwise it implements an emulator (providing only `EPOLLIN`, `EPOLLOUT`
 and a non standard version of EPOLLHUP/EPOLLRDHUP).
 .
 This package contains the shared library.

Package: vpoll-dkms
Section: kernel
Architecture: all
Depends: ${misc:Depends}
Recommends: libvpoll0
Description: vpoll device: generate events for poll/select/ppoll/pselect/epoll
 This kernel module creates the vpoll device for libvpoll.
 This package provides the source code for the vpoll kernel module and makes use
 of the DKMS build utility to install it for the running kernel.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with=dkms

override_dh_install:
	dh_install -Nvpoll-dkms
	dh_install -pvpoll-dkms \
		linux_module/* usr/src/vpoll-$(DEB_VERSION_UPSTREAM)/
	dh_install -pvpoll-dkms \
		debian/vpoll-dkms.conf etc/modules-load.d

override_dh_dkms:
	dh_dkms -V $(DEB_VERSION_UPSTREAM)

override_dh_auto_install:
	dh_auto_install --destdir debian/tmp

## libvpoll-eventfd 0.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,3 +33,6 @@
         DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
 add_subdirectory(man)
+
+add_custom_target(uninstall
+  "${CMAKE_COMMAND}" -P "${PROJECT_SOURCE_DIR}/Uninstall.cmake")

=== linux_module/Makefile ===
--- 
+++ 
@@ -5,4 +5,7 @@
 clean:
 	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) clean
 
+install:
+	install -D vpoll.ko /lib/modules/$(shell uname -r)/misc/vpoll.ko
+	depmod -a

=== debian/changelog ===
libvpoll-eventfd (0.1.1-1) unstable; urgency=medium

  [ Renzo Davoli ]
  * New upstream release 0.1.1.
    + Fix support for Linux 6.2+.  Closes: #1038005
  * Bump Standards-Version to 4.6.2, no changes needed.

  [ Mattia Rizzolo ]
  * Drop uupdate from d/watch.

 -- Renzo Davoli <renzo@cs.unibo.it>  Sun, 18 Jun 2023 18:28:25 +0200

libvpoll-eventfd (0.1-3) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Switch to dh-sequence-dkms.
  * Declare Testsuite: autopkgtest-pkg-dkms.
  * Do not use deprecated dkms feature REMAKE_INITRD.

  [ Andrea Capriotti ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on cmake.
  * Bump Standards-Version to 4.6.1, no changes needed.
  * d/copyright: Update Debian copyright

 -- Andrea Capriotti <capriott@debian.org>  Sun, 14 Aug 2022 16:36:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: libvpoll-eventfd
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
+Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
 Uploaders: Mattia Biondi <mattia.biondi3@studio.unibo.it>, Renzo Davoli <renzo@cs.unibo.it>, Andrea Capriotti <capriott@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake (>= 3.12), libfduserdata-dev (>= 0.1),
-  dkms
-Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13), cmake, libfduserdata-dev (>= 0.1), dh-sequence-dkms
+Standards-Version: 4.6.2
 Section: libs
 Homepage: http://www.virtualsquare.org/
 Vcs-Git: https://salsa.debian.org/virtualsquare-team/libvpoll-eventfd.git
 Vcs-Browser: https://salsa.debian.org/virtualsquare-team/libvpoll-eventfd
 Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-dkms
 
 Package: libvpoll-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@ --with=dkms
+	dh $@
 
 override_dh_install:
 	dh_install -Nvpoll-dkms

=== debian/watch ===
version=4

https://github.com/rd235/libvpoll-eventfd/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
